set Simulation TRUE
set mach_o 0800
set macl_o 306c2775

if {$Simulation} {
      puts "Note: Simulation"
	  set g_simulation 1
	} else {
      puts "Note: Synthesis"
	  set g_simulation 0
	}

source VSim_Current_Revision.tcl

puts "elf file used for lm32 in WRPC: [set elf_file_lm32_wrpc "..\\..\\sw\\embedded\\wrpc-sw-simu\\wrc.elf"]"

# !!! Note !!!: Don't forget to compile the software (elf file) for simulation (avoid printf etc. to speed up simulation time)
# !!! Note !!!: The double \\ are there since the DOS command below needs backslashes and a single backslash is seen as a switch in tcl

# Generate a "lm32_memory.mem" file from the "elf" file content
# Note that ISE 12.4 data2mem produces wrong results; use an older version:
#exec cmd.exe /c data2mem.exe -bd $elf_file_lm32_wrpc -d -o m lm32_wrpc_memory.mem

# Convert the "mem" to a "ldr" (a format used by the White Rabbit "memory_loader_pkg.vhd"
#do mem2ldr.tcl lm32_wrpc_memory

# Note that -novopt causes No Optimization (some internal signals might get non-vivible by optimization)
# Note that "-L unisim" is needed to find the primitive "BSCANE2" thta is instantiated in "$LM32_Sources/platform/kintex7/jtag_tap.v "
#suppress warning Warning: (vsim-151) NUMERIC_STD.TO_INTEGER: Value <> is not in bounds of NATURAL.
#suppress warning Warning: (vsim-8684) No drivers exist on out port <blabla>
vsim -voptargs="+acc" -novopt \
	+nowarn151 \
	+nowarn8684 \
	-t ps -L unisim -lib work work.spec_wr_ref_top_tb

#	-G/spec_wr_ref_top_tb/u1/g_simulation=$g_simulation \
# -G/spec_wr_ref_top_tb/u5/U_GTP/g_simulation=$g_simulation \
# -G/spec_wr_ref_top_tb/u5/U_WR_CORE/g_simulation=$g_simulation \
#	-G/spec_wr_ref_top_tb/u5/U_WR_CORE/WRPC/DPRAM/g_must_have_init_file=true \
#	-G/spec_wr_ref_top_tb/u5/U_WR_CORE/WRPC/DPRAM/g_init_file=lm32_wrpc_memory.ldr \


do wave.tcl
do wave_split_ram.tcl

view signals

# Force endpoint wishbone registers (entity ep_wishbone_controller regs_o)
#	force MAC address
#force -freeze /spec_wr_ref_top_tb/u5/U_WR_CORE/WRPC/U_Endpoint/U_Wrapped_Endpoint/regs_fromwb.mach_o 16#$mach_o
#force -freeze /spec_wr_ref_top_tb/u5/U_WR_CORE/WRPC/U_Endpoint/U_Wrapped_Endpoint/regs_fromwb.macl_o 16#$macl_o

force -freeze /spec_wr_ref_top_tb/clk_20m_vcxo_p_i 1, 0 25 ns -rep 50 ns

force -freeze /spec_wr_ref_top_tb/button1_i 0, 1 4 us
force -freeze /spec_wr_ref_top_tb/Rx_Fire 0
# "Fire" Starts transmission of UDP packets to Linux Server.

#run 500 us so wrpc lm32 has initialized the endpoint registers
run 700 us

run 18 us

#  stop

set testrx true
if { $testrx == true} {
	# Test Receive UDP packets from server PC

	force -freeze /spec_wr_ref_top_tb/Rx_Fire 1,0 128 ns
	
	run 800 ns

    # Test Pause frame generation after WaterMarkHigh
#    force -freeze /spec_wr_ref_top_tb/U_WR_CORE/U_WR_CORE/u6/u2/WaterMarkHigh 1
	run 80 us
#    noforce /spec_wr_ref_top_tb/U_WR_CORE/U_WR_CORE/u6/u2/WaterMarkHigh

	
} else {
	# Test Transmit UDP packets to server PC

	force -freeze /spec_wr_ref_top_tb/button2_i 0,1 128 ns

}
run 1 us

run 12 us

wave zoom full

#
# End
#
