rem fpga-xilinx.cmd  PeterJ,    19-Dec-2017.
@prompt $$$s

set lm32_wrpc_initf=..\..\..\wr-cores\bin\wrpc\wrc_phy8.bram

set UseXST=true
set DesName=spec_wr_ref_top

rem SPEC
set PartName=xc6slx45t-fgg484-3

set ArchPath=..\..\wr-cores\ip_cores\gn4124-core\hdl\spec\ip_cores\

set LogName=%DesName%-xilinx.log

@rem ---------------------------------------------------------------------

if %UseXST%==true (
   xtclsh revisiondate.tcl
	 set n=0  
	 for /f "tokens=*" %%a in (revisiondate_log.txt) do call :dosomething %%a
	 goto donext

:dosomething
	 @echo Now working with %1
	 set /a currentdate=0x%currentrevision%
	 set currentrevision=%1
	 goto :eof

:donext
   @echo "current date: %currentdate%"
   @echo "current revision: %currentrevision%"

  rem ---- Xilinx XST -----------------------------------------------------
  rem Prepare xilinxs ".prj" and ".ise"
  rem ---------------------------------------------------------------------
  conv_file_list_to_xilinx.py file_list.txt -o %DesName%

) else (
  rem ---- Precision Synthesis --------------------------------------------
)

mkdir work
cd work
del *.* /S /Q

@echo Started implementation of %DesName% on %date% at %time% > ..\%LogName%

copy ..\..\..\wr-cores\top\spec_ref_design\%DesName%.ucf .
copy ..\%DesName%.ut .

if %UseXST%==true (
   copy ..\%DesName%_xst.bmm %DesName%.bmm 
   rem Xilinx XST needs a projnav.tmp directory
   mkdir xst\projnav.tmp
   copy ..\%DesName%.xst .
   copy ..\%DesName%.prj .
   rem copy revision generics in temporary ".xst" file
   rem @echo -generics {g_revision_id=%currentrevision% g_date_id=%currentdate% g_lm32_wrpc_initf="..\%lm32_wrpc_initf%"} >> %DesName%.xst
   @echo xst ... >> ..\%LogName%
   xst -intstyle xflow -ifn %DesName%.xst -ofn %DesName%.syr >> ..\%LogName%

   @echo ngdbuild ... >> ..\%LogName%
   ngdbuild -intstyle xflow -dd . -uc %DesName%.ucf -sd ..\%ArchPath% -bm %DesName%.bmm -nt timestamp  -p %PartName% %DesName%.ngc %DesName%.ngd >> ..\%LogName%
) else (
   copy ..\%DesName%_precision.bmm %DesName%.bmm 
   @echo ngdbuild ... >> ..\%LogName%
   ngdbuild -intstyle xflow -dd . -uc %DesName%.ucf -sd ..\%ArchPath% -bm %DesName%.bmm -nt timestamp  -p %PartName% %DesName%.edf >> ..\%LogName%
)

@echo map ... >> ..\%LogName%
map   -intstyle xflow -p %PartName% -w -logic_opt off -ol high -timing -t 1 -xt 0 -register_duplication off -r 4 -mt off -ir off -pr off -lc off -power off -o %DesName%_map.ncd %DesName%.ngd %DesName%.pcf >> ..\%LogName%

@echo par ... >> ..\%LogName%
par -w -intstyle xflow -ol high -mt off %DesName%_map.ncd %DesName%.ncd %DesName%.pcf >> ..\%LogName%

@echo trce ... >> ..\%LogName%
trce -intstyle xflow -v 3 -s 1 -n 3 -fastpaths -xml %DesName%.twx %DesName%.ncd -o %DesName%.twr %DesName%.pcf >> ..\%LogName%

@echo bitgen ... >> ..\%LogName%
bitgen -intstyle xflow -f %DesName%.ut %DesName%.ncd >> ..\%LogName%

#@echo netgen ... >> ..\%LogName%
#netgen -intstyle xflow -s 2 -pcf %DesName%.pcf -rpw 100 -tpw 0 -ar Structure -a -insert_pp_buffers true -w -dir netgen/par -ofmt vhdl -sim %DesName%.ncd %DesName%_timesim.vhd >> ..\%LogName%

@echo copy bitfile ... >> ..\%LogName%
copy  %DesName%.bit ..\%DesName%.bit
copy  %DesName%_bd.bmm ..\%DesName%_bd.bmm
